const
  maxN = 50;

type
  TPoint  = record
              X, Y: real;
            end;
  TPoly   = array [1..maxN] of TPoint;
  TPoints = array [1..(maxN*maxN+maxN)] of TPoint;

var
  N, Count: integer;
  V: TPoly;
  PL: TPoints;
  X,Y: real;
  Answer: boolean;

procedure Stop(const s: string);
begin
  writeln('PCheck message: '+s);
end;


procedure Init;
var
  F: text;
  i: integer;
begin
  Count := 0;
  { input }
  {$I-}
  assign(F, 'input.txt');
  reset(F);
  if IOResult <> 0 then Stop('input.txt  .');
  readln(F, N);
  for i := 1 to N do readln(F, V[i].X, V[i].Y);
  close(F);
end;

function Left(P1, P2, P3: TPoint): real;
begin
  Left := P1.X*P2.Y + P1.Y*P3.X + P2.X*P3.Y -
          P3.X*P2.Y - P1.Y*P2.X - P1.X*P3.Y;
end;

procedure AddToPL(P: TPoint);
var
  i: integer;
begin
  for i := 1 to N do
      if Left(V[i], V[i mod N + 1], P) < 0 then exit;
  inc(Count);
  PL[Count] := P;
end;

function Cross(P1, P2, P3, P4: TPoint; var P: TPoint): boolean;
var
  a1, b1, c1,
  a2, b2, c2, d: real;
begin
  a1 := P2.Y - P1.Y; b1 := P1.X - P2.X; c1 := a1*P1.X + b1*P1.Y;
  a2 := P4.Y - P3.Y; b2 := P3.X - P4.X; c2 := a2*P3.X + b2*P3.Y;
  d := a1*b2 - a2*b1;
  if d = 0
     then Cross := false
     else begin
            Cross := true;
            P.X := (c1*b2-c2*b1) / d;
            P.Y := (a1*c2-a2*c1) / d;
          end;
end;

procedure Main;
var
  i, j: integer;
  P: TPoint;
begin
  for i := 1 to N do AddToPL(V[i]);
  for i := 1 to N-1 do
      for j := i+1 to N do
      if Cross(V[i],V[i+1], V[j], V[j mod n + 1], P)
         then AddToPL(P);
end;

function Check: boolean;
const
  e = 0.001;
var
  a,b,c: real;
  i: integer;
begin
  i := 2;
  while (i<=count) and (PL[1].X = PL[i].X) and (PL[1].Y = PL[i].Y) do inc(i);
  if i > count
     then begin
            Check := true;
            exit;
          end
     else Check := false;
  a := PL[i].Y - PL[1].Y; b := PL[1].X - PL[i].X;
  c := -a*PL[1].X-b*PL[1].Y;
  for i := 1 to Count do
      if abs(a*PL[i].X+b*PL[i].Y+c) > e then exit;
  Check := true;
end;

procedure CalcRes;
var
  i: integer;
begin
  if (Count < 3) or Check
     then Answer := false
     else begin
            Answer := true;
            X := 0;
            Y := 0;
            for i := 1 to Count do
            begin
              X := X + PL[i].X;
              Y := Y + PL[i].Y;
            end;
            X := X / Count;
            Y := Y / Count;
          end;
end;

procedure Test;
var
  F: text;
  PP: TPoint;
  S,SS: string;
  i: integer;
  fl: boolean;
begin
  assign(F,'output.txt');
  {$I-}
  reset(F);
  if IOResult <> 0 then writeln('  output.txt');
  if Answer
     then begin
            readln(F, PP.x, PP.y);
            if IOResult <> 0
               then writeln('⢥  ७')
               else begin
                      fl := true;
                      for i := 1 to N do
                          if Left(V[i], V[i mod N + 1], PP) <= 0 then fl := false;
                      if fl
                         then writeln('Ok!')
                         else writeln('⢥  ७');
                    end;
          end
     else begin
            readln(F, S);
            SS := '';
            for i := 1 to length(S) do
                if S[i] in ['a'..'z','A'..'Z'] then SS := SS + upcase(S[i]);
            if SS = 'NOPOINT'
               then writeln('Ok!')
               else writeln('⢥  ७');
          end;

end;

begin
  Init;
  Main;
  CalcRes;
  writeln('⢥ ⢥:');
  if Answer
     then writeln(X:2:3, ' ',Y:2:3)
     else writeln('NO POINT');
  writeln('******************');
  Test;
end.
